#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <time.h>
#include <cmath>
#define nsite 30
#define ndim 4
#define n_iter 30
#define Pi 3.14159265359
#define c 300000000
int x[ndim], mu, nu, s;
int iter, k, ki;
float v, beta, dS_tr;

#include "matriks_kompleks.h"

Matriks U[nsite*nsite*nsite*nsite][ndim], M_SU2, old_U;

#include "matriks_su2.h"
#include "lattice.h"

using namespace std;

int main()
{
    beta = 0.6;
    v = 0.9;
    srand(time(0));
    cout << "Inisialisasi link" << endl;
    inisialisasi();
    cout << "Metropolis Update" << endl;
    for(iter=0; iter<n_iter; iter++){
        Metropolis_Update();
        cout << iter << "      " << plaquette(1,1) << endl;
    }
    cout << "done" << endl;
    return 0;
}
