#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <time.h>
#include <cmath>
#define nsite 10
#define ndim 4
#define n_iter 30
#define Pi 3.14159265359
#define c 300000000
#define kop 1.0
#define lat 14.5
int x[ndim], mu, nu, s;
int iter, k, ki, vi;
float v, beta, dS_tr, lorentz, jac, spc;

#include "matriks_kompleks.h"

Matriks U[nsite*nsite*nsite*nsite][ndim], M_SU2, old_U;

#include "matriks_su2.h"
#include "lattice.h"

using namespace std;

int main()
{
    /*beta = 4N/g^2 dipilih g = 1 N = 2 karena SU2*/
    beta = 4.0/(kop*kop);
    spc = lat/(nsite-1.0);
    jac = -1.0/(kop*kop*kop*kop*spc*spc*spc*spc);
    //cout << "GOOOO" << endl;
    for (vi=0;vi<40;vi++){
       srand(time(0));
       v = 0.025*vi;
       lorentz = eps(0)*eps(1)*eps(2)*eps(3);
       //cout << "Inisialisasi link" << endl;
       inisialisasi();
       //cout << "Metropolis Update" << endl;
       for(iter=0; iter<n_iter; iter++){
           Metropolis_Update();
           //cout << iter << "      " << plaquette(1,1) << endl;
       }
       cout << v << "      " << jac*lorentz*plaquette(1,1) << endl;
    }
    //cout << "done" << endl;
    return 0;
}
