#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>

Matriks plaqsum, plaq, U0, U1, U2, U3, Uprod;
Matriks staplesum, staple, dS;

int getsite(int x[]){
    int s = x[0]+nsite*(x[1]+nsite*(x[2]+nsite*x[3]));
    return s;
}

float eps(int i){
    float result=0;
    if (i==0){
        result = (v*v)/(1-v*v) ;
    }
    else
    {
        result = -v/sqrt(1-v*v);
    }
    return result;
}


float KONST(int i, int j){
    float result2 = 0;
    if (i==0)
    {
        result2 = 2*eps(0)*eps(j);
    }
    else
    {
        result2 = eps(i)*eps(j);
    }
    return result2;
}

void inisialisasi(){
    for (x[0]=0;x[0]<nsite;x[0]++){
    for (x[1]=0;x[1]<nsite;x[1]++){
    for (x[2]=0;x[2]<nsite;x[2]++){
    for (x[3]=0;x[3]<nsite;x[3]++){
    	s=getsite(x);
	for (mu=0;mu<ndim;mu++){
            U[s][mu].identity();
    	}
    }}}}
}

void moveup(int x[],int d){
	x[d]+=1;
	if (x[d]>=nsite) x[d]-=nsite;
}

void movedown(int x[],int d){
	x[d]-=1;
	if (x[d]<0) x[d]+=nsite;
}

float plaquette(int i,int j){
    int s;
    plaqsum.nol();
    int kkk=0;
    int mu, nu, ii, jj;
    for (mu=0;mu<ndim;mu++){
    for (nu=0;nu<ndim;nu++){
    if (nu > mu){
        for (x[0]=0;x[0]<nsite;x[0]++){
    	for (x[1]=0;x[1]<nsite;x[1]++){
	for (x[2]=0;x[2]<nsite;x[2]++){
    	for (x[3]=0;x[3]<nsite;x[3]++){
            s=getsite(x);
            Uprod.nol();U0.nol();U1.nol();U2.nol();U3.nol();
	    U[s][0].dagger(); U0=U[s][0];U[s][0].dagger();
            U[s][1].dagger(); U1=U[s][1];U[s][1].dagger();
            U[s][2].dagger(); U2=U[s][2];U[s][2].dagger();
            U[s][3].dagger(); U3=U[s][3];U[s][3].dagger();
            Uprod = U0*U1*U2*U3;
            kkk += 1;
            plaq.nol();
	    plaq = U[s][mu];
	    for (ii=0;ii<(i-1);ii++){
	        moveup(x,mu);
		plaq = plaq*U[s][mu];
	    }
	    moveup(x,mu);
	    plaq = plaq*U[s][nu];
            for (jj=0;jj<(j-1);jj++){
		moveup(x,nu);
  		plaq=plaq*U[s][nu];
	    }
	    moveup(x,nu);
	    movedown(x,mu);
	    U[s][mu].dagger();
	    plaq = plaq*U[s][mu];
            U[s][mu].dagger(); //back
	    for (ii=0;ii<(i-1);ii++){
		movedown(x,mu);
		U[s][mu].dagger();
		plaq=plaq*U[s][mu];
                U[s][mu].dagger(); //back
	    }
	    for (jj=0;jj<j;jj++){
		movedown(x,nu);
		U[s][nu].dagger();
		plaq=plaq*U[s][nu];
                U[s][nu].dagger(); //back
	    }
	    plaq.kali(KONST(mu,nu));
            plaq=Uprod*plaq;
            plaqsum = plaqsum + plaq;
        }}}
    }}}}
    return beta*(1-0.5*(plaqsum.retrace()/(kkk)));
}

void hitungstaple(){
    staplesum.nol();
    for (nu=0;nu<ndim;nu++){
	if (nu > mu){
	    staple.nol();
	    moveup(x,mu);
	    staple = U[s][nu];
	    moveup(x,nu);
	    movedown(x,mu);
            U[s][mu].dagger();
	    staple = staple*U[s][mu];
            U[s][mu].dagger();    //back
	    movedown(x,nu);
	    U[s][nu].dagger();
	    staple = staple*U[s][nu];
            U[s][nu].dagger();    //back
	    staplesum = staplesum + staple;
            staplesum.kali(KONST(mu,nu));
	    /*staple.nol();
	    moveup(x,mu);
	    movedown(x,nu);
	    U[s][nu].dagger();
	    staple = U[s][nu];
	    movedown(x,mu);
	    U[s][mu].dagger();
	    staple = staple*U[s][mu];
	    staple = staple*U[s][nu]);
	    staplesum = staplesum*staple;*/
	}
    }
}

void Metropolis_Update(){
    for(mu=0; mu<ndim; mu++){
        for (x[0]=0;x[0]<nsite;x[0]++){
	for (x[1]=0;x[1]<nsite;x[1]++){
	for (x[2]=0;x[2]<nsite;x[2]++){
	for (x[3]=0;x[3]<nsite;x[3]++){
	    s=getsite(x);
            hitungstaple();
            old_U = U[s][mu];
            GenSU2();
            //M_SU2.printm();
            U[s][mu]=M_SU2;
            dS=(U[s][mu]-old_U)*staplesum;
            dS.kali(beta);
            float dS_tr = dS.retrace();
            float u = rand()/(RAND_MAX+1.0);
	    if (dS_tr >0 && exp(-dS_tr)< u){
		U[s][mu]=old_U;
                //cout << "terima" << endl;
            } 
            //cout << "tolak" << endl;
        }}}}
    }
}
