#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>


double a[4], phi, sin_alpha, sin_theta, cos_theta;


using namespace std;

void GenSU2()
{
    M_SU2.nol();
    a[0]=2.0*(rand()/(RAND_MAX+1.0))-1.0;
    cos_theta=2.0*(rand()/(RAND_MAX+1.0))-1.0;
    sin_theta=sqrt(1.0-cos_theta*cos_theta);
    sin_alpha=sqrt(1-a[0]*a[0]);
    phi=2.0*Pi*(rand()/(RAND_MAX+1.0));
    a[1]=sin_alpha*sin_theta*cos(phi);
    a[2]=sin_alpha*sin_theta*sin(phi);
    a[3]=sin_alpha*cos_theta;
    M_SU2.re[0][0]=a[0];
    M_SU2.im[0][0]=a[3];
    M_SU2.re[0][1]=a[2];
    M_SU2.im[0][1]=a[1];
    M_SU2.re[1][0]=-a[2];
    M_SU2.im[1][0]=a[1];
    M_SU2.re[1][1]=a[0];
    M_SU2.im[1][1]=-a[3];
}
